/* MakeFlexi
 * Programm zur Erzeugung einer Schubladenunterteilun durch Lasercutter
 * in 2D zum Export als DXF-Datei,
 * Laserstrahldicke wird nicht berücksichtigt!
 * Stefan Abel 2016
 *
 *
 */
 
//Definition von Variablen
Breite = 128;        //in X-Richtung (Ikea 233)
Hoehe = 250;         //in Y-Richtung (Ikea 392)
Tiefe = 20;          //in Z-Richtung (Ikea 95)
 
X_Teilung = 5;       //Anzahl der Fächer in X-Richtung
Y_Teilung = 4;       //Anzahl der Fächer in Y-Richtung

Materialdicke = 2.8;
Ausgabeabstand = 2;

Ausgabeart = 2;      // in 2D(DXF):2  in 3D(STL):3  in 3D versetzt:4

//Hauptprogramm

X_Abstand = (Breite-(X_Teilung-1)*Materialdicke)/X_Teilung+0.01;
Y_Abstand = (Hoehe-(Y_Teilung-1)*Materialdicke)/Y_Teilung+0.01;
echo ("Fachgröße innen:",X_Abstand,Y_Abstand);

if (Ausgabeart == 2) 
   {
      for (xi = [0:Breite/(X_Abstand+Materialdicke)-1])
      {
      projection(cut = false) translate([(xi*(Tiefe+Ausgabeabstand)+Ausgabeabstand),Ausgabeabstand,0]) rotate([0,90,0]) X_Unterteilung();
      }  
   for (yi = [0:Hoehe/(Y_Abstand+Materialdicke)-1])
      {
      projection(cut = false) translate([(yi+1)*(Tiefe+Ausgabeabstand),-Ausgabeabstand,0]) rotate([90,0,-90]) Y_Unterteilung();
      }
   }

if (Ausgabeart == 3)
   {
   X_Unterteilung();
   Y_Unterteilung();
   }

if (Ausgabeart == 4)
   {
   X_Unterteilung();
   translate ([0,0,-Tiefe]) Y_Unterteilung();
   }


//Unterprogramm als Module

module X_Unterteilung()
{
   for (x = [X_Abstand:X_Abstand+Materialdicke:Breite])
   {
      difference ()
      {  
         translate([x,0,0])
         cube([Materialdicke,Hoehe,Tiefe], false);
         for (y = [Y_Abstand:Y_Abstand+Materialdicke:Hoehe])
         {   
         translate([x,y,0])
         cube([Materialdicke,Materialdicke,Tiefe/2], false);
         }   
      }
   }      
}

module Y_Unterteilung()
{
   for (y = [Y_Abstand:Y_Abstand+Materialdicke:Hoehe])
   {
   difference ()
      {
      translate([0,y,0])
      cube([Breite,Materialdicke,Tiefe], false);
         for (x = [X_Abstand:X_Abstand+Materialdicke:Breite])
         {   
         translate([x,y,Tiefe/2])
         cube([Materialdicke,Materialdicke,Tiefe/2], false);
         }   
      }
   }
}