/* Fingerpassung
 * Programm zur Erzeugung einer Fingerpassung durch Lasercutter
 * in 2D zum Export als DXF-Datei,
 * Laserstrahldicke wird berücksichtigt!
 * Stefan Abel 2016
 *
 *
 */
 
//Definition von Variablen
Breite = 100;        //in Y-Richtung
Hoehe = 20;         //in X-Richtung

Fingerbreite = 5;
Fingerabstand = 10;
Fingertiefe = 3;
Materialdicke = 3;

PN = 0.08;   //Passnocke zur besseren Passung
Laserdicke = 0.15;   //Laserstrahldicke
            //HDF 5mm: 0.10 (19mm/s;60/58%)
            //HDF 3mm: 0.15 (35mm/s;60/58%)
            
LDH = Laserdicke*0.5;
echo (LDH);


Ausgabeabstand = 2;

//Ausgabeart = 2;      // in 2D(DXF):2  in 3D(STL):3  in 3D versetzt:4


//Hauptprogramm
Fingerteil();
//Nutenteil();
//Schlitzteil();

translate([0,-Fingertiefe-Ausgabeabstand,0]) Nutenteil();
translate([0,-Fingertiefe-Ausgabeabstand*2-Hoehe*2,0]) Schlitzteil();

//Unterprogramm als Module

module Fingerteil()
union() 
{
   polygon(points=[[-LDH,0],[Breite+LDH,0],[Breite+LDH,Hoehe+LDH],[-LDH,Hoehe+LDH]]);
   for (x = [Fingerabstand:Fingerabstand+Fingerbreite:Breite-Fingerbreite])
      {
      polygon(points=[[x-LDH,0],[x-LDH,-Fingertiefe*0.2],[x- LDH-PN,-Fingertiefe*0.4],[x-LDH-PN,-Fingertiefe*0.6],[x-LDH,-Fingertiefe*0.8],[x-LDH,-LDH-Fingertiefe],[x+LDH+Fingerbreite,-LDH-Fingertiefe],[x+LDH+Fingerbreite,-Fingertiefe*0.8],[x+LDH+Fingerbreite+PN,-Fingertiefe*0.6],[x+LDH+Fingerbreite+PN,-Fingertiefe*0.4],[x+LDH+Fingerbreite,-Fingertiefe*0.2],[x+LDH+Fingerbreite,0]]);
      }
            
}

module Nutenteil()

difference() 
{
   polygon(points=[[-LDH,0],[Breite+LDH,0],[Breite+LDH,-Hoehe-LDH],[-LDH,-Hoehe-LDH]]);
   for (x = [Fingerabstand:Fingerabstand+Fingerbreite:Breite-Fingerbreite])
      {
      polygon(points=[[x+LDH,0],[x+LDH,-Fingertiefe+LDH],[x-LDH+Fingerbreite,-Fingertiefe+LDH],[x-LDH+Fingerbreite,0]]);
      }
}

module Schlitzteil()

difference() 
{
    polygon(points=[[-LDH,0],[Breite+LDH,0],[Breite+LDH,Hoehe+LDH],[-LDH,Hoehe+LDH]]);
   for (x = [Fingerabstand:Fingerabstand+Fingerbreite:Breite-Fingerbreite])
      {
      translate([0,Hoehe*0.5-Fingertiefe*0.5,0]) polygon(points=[[x+LDH,LDH],[x+Fingerbreite-LDH,LDH],[x+Fingerbreite-LDH,Materialdicke-LDH],[x+LDH,Materialdicke-LDH]]);
      }
}

